/***************************************************************
 * Name:      nombres.cpp
 * Purpose:   Code for Dialog nombres de entradas
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-09-25
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "nombres.h"

BEGIN_EVENT_TABLE(nombresEntradas, wxDialog)
    EVT_CLOSE(nombresEntradas::OnClose)
END_EVENT_TABLE()

nombresEntradas::nombresEntradas(wxWindow *wnd, datosProyecto &datos)
    : wxDialog(wnd, -1, "Nombres de entradas")
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;
    std::vector<wxTextValidator*> valTexto; // = wxTextValidator(wxFILTER_SPACE|wxFILTER_ALPHANUMERIC, &datos.Nombre());
    std::vector<wxTextCtrl*> ctrlNombre;
    wxString etiqueta;

    boxVertical = new wxBoxSizer(wxVERTICAL);

    for(int i=0; i<datos.NBits(); i++) {
        valTexto.push_back(new wxTextValidator(wxFILTER_SPACE|wxFILTER_ALPHANUMERIC, &datos.Etiqueta()[i]));
        boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
        etiqueta.Printf(wxT("Bit %d"), i);
        boxHorizontal->Add(new wxStaticText(this, wxID_ANY, etiqueta), wxSizerFlags().Border());
        ctrlNombre.push_back(new wxTextCtrl(this, idEntrada+i, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, *valTexto[i]));
        boxHorizontal->Add(ctrlNombre[i], wxSizerFlags().Border());
        boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());
    }

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

void nombresEntradas::OnClose(wxCloseEvent &event)
{
    Destroy();
}

